Packages - Freedom Issue #2791

[spyder] depends on webengine
2020-06-06 08:38 AM - libreuser

Status: confirmed % Done: 0%
Priority: freedom issue

Assignee:

Category:

Description

LC_ALL=C pacman -S spyder

resolving dependencies...

warning: cannot resolve "python-pyqtwebengine”, a dependency of "spyder"

:: The following package cannot be upgraded due to unresolvable dependencies:
spyder

Subtasks:
Bug # 3448: spyder needs to be rebuilt against new re2 (Version : 1:20230201-1)

unconfirmed

Related issues:

Related to Packages - Freedom Issue #1167: [chromium][electron][gt5-webengine... confirmed
Related to Packages - Packaging Request #2874: [python2-*]: multiple packages... open
History

#1 - 2020-06-11 11:49 PM - bill-auger

- Related to Freedom Issue #1167: [chromium][electron][qt5-webengine][qt6-webengine] QTWebgine/Electron embeds "entire Chromium platform"

added

#2 - 2020-06-11 11:51 PM - bill-auger

- Priority changed from bug to freedom issue

- Status changed from unconfirmed to confirmed

- Subject changed from [spyder] unresolvable dependencies to [spyder] depends on webengine

- Tracker changed from Bug to Freedom Issue

spyder depends on webengine, which is blacklisted with no libre replacement - that make spyder yet another candidate for libreation/blacklisting for

that reason

#3 - 2023-02-19 02:27 AM - bill-auger
- Related to Bug #3448: spyder needs to be rebuilt against new re2 (Version : 1:20230201-1) added

#4 - 2023-02-19 07:08 AM - bill-auger

i tried to de-webengine this; but that may not be possible - it appears to be essential - the program will not even start without instantiating a
'WebPage', subclass of 'QWebEnginePage' for the help system - the application even has a CLI option '--no-web-widgets', which i set hard-coded; but

webengine is still required at runtime

webengine appears to be used only for the help system - if so, maybe the help system can be removed, with a bit more effort

i will add the WIP patch under abslibre libre-testing/spyder; but i am not going to continue now - it would need deeper surgery to make a libre

replacement - for now, i am just going to blacklist it with no replacement

Traceback (most recent call last):

File "/usr/bin/spyder", line 33, in <module>
sys.exit (load_entry_point ('spyder==5.4.1', 'gui_scripts', 'spyder') ())

File "/usr/lib/python3.10/site-packages/spyder/app/start.py", line 252, in main
mainwindow.main (options, args)

File "/usr/lib/python3.10/site-packages/spyder/app/mainwindow.py", line 1819, in main
mainwindow = create_window (MainWindow, app, splash, options, args)

File "/usr/lib/python3.10/site-packages/spyder/app/utils.py", line 289, in create_window
main.setup ()
File "/usr/lib/python3.10/site-packages/spyder/app/mainwindow.py", line 728, in setup
internal_plugins = find_internal_plugins ()

File "/usr/lib/python3.10/site-packages/spyder/app/find_plugins.py", line 40, in find_internal_plugins
mod = importlib.import_module (entry_point.module_name)

File "/usr/lib/python3.10/importlib/__init__.py", line 126, in import_module
return _bootstrap._gcd_import (name[level:], package, level)

File "<frozen importlib._bootstrap>", line 1050, in _gcd_import

File "<frozen importlib._bootstrap>", line 1027, in _find_and_load

File "<frozen importlib._bootstrap>", line 1006, in _find_and_load_unlocked

File "<frozen importlib._bootstrap>", line 688, in _load_unlocked

File "<frozen importlib._bootstrap_external>", line 883, in exec_module

File "<frozen importlib._bootstrap>", line 241, in _call_with_frames_removed

File "/usr/lib/python3.10/site-packages/spyder/plugins/help/plugin.py", line 26, in <module>
from spyder.plugins.help.widgets import HelpWidget

File "/usr/lib/python3.10/site-packages/spyder/plugins/help/widgets.py", line 39, in <module>
from spyder.widgets.browser import FrameWebView

File "/usr/lib/python3.10/site-packages/spyder/widgets/browser.py", line 68, in <module>
class WebPage (QWebEnginePage) :

NameError: name 'QWebEnginePage' is not defined

the help system is a plugin (apparently), which means it should be optional; but when i delete the plugin, it still fails; because elsewhere in the
program, the "plugin” is strictly required

Traceback (most recent call last):
File "/usr/bin/spyder", line 33, in <module>
sys.exit (load_entry_point ('spyder==5.4.1', 'gui_scripts', 'spyder') ())
File "/usr/lib/python3.10/site-packages/spyder/app/start.py", line 252, in main
mainwindow.main (options, args)
File "/usr/lib/python3.10/site-packages/spyder/app/mainwindow.py", line 1819, in main
mainwindow = create_window (MainWindow, app, splash, options, args)
File "/usr/lib/python3.10/site-packages/spyder/app/utils.py", line 289, in create_window
main.setup ()
File "/usr/lib/python3.10/site-packages/spyder/app/mainwindow.py", line 728, in setup
internal_plugins = find_internal_plugins ()
File "/usr/lib/python3.10/site-packages/spyder/app/find_plugins.py", line 40, in find_internal_ plugins
mod = importlib.import_module (entry_point.module_name)
File "/usr/lib/python3.10/importlib/__init__.py", line 126, in import_module
return _bootstrap._gcd_import (name[level:], package, level)
File "<frozen importlib._bootstrap>", line 1050, in _gcd_import
File "<frozen importlib._bootstrap>", line 1027, in _find_and_load
File "<frozen importlib._bootstrap>", line 1004, in _find_and_load_unlocked
ModuleNotFoundError: No module named 'spyder.plugins.help.plugin'

FWIW, i saw a patch upstream that makes it require webengine only for python 3 - however python 2 is gone now - its not decided if we should bring
it back (#2874)

#5 - 2023-02-19 07:28 AM - bill-auger
- Related to Packaging Request #2874: [python2-"]: multiple packages dropped from arch added
